const { DataTypes } = require("sequelize");

module.exports = (sequelize) => {
	const BudgetCategory = sequelize.define(
		"budgetcategorie",
		{
			id: {
				type: DataTypes.INTEGER,
				autoIncrement: true,
				primaryKey: true,
			},
			creation: { type: DataTypes.DATE, allowNull: false },
			modified: { type: DataTypes.DATE, allowNull: false },
			modified_by: { type: DataTypes.INTEGER, allowNull: false },
			owner: { type: DataTypes.INTEGER, allowNull: false },
			enabled: { type: DataTypes.BOOLEAN, allowNull: false },

			// main
			name: { type: DataTypes.STRING(150), allowNull: false },
			code: { type: DataTypes.STRING(50), allowNull: false },
			display_name: { type: DataTypes.STRING(50), allowNull: false },
			description: { type: DataTypes.TEXT, allowNull: true },
			accounting_treatment: { type: DataTypes.TEXT, allowNull: true },
			color: { type: DataTypes.STRING(50), allowNull: true },

			// fk
			company_id: { type: DataTypes.INTEGER, allowNull: true },
		},
		{
			tableName: "bugdetcategories",
			freezeTableName: true,
		}
	);

	BudgetCategory.associate = (models) => {
		BudgetCategory.belongsTo(models.User, { foreignKey: "modified_by", as: "modifier" });
		BudgetCategory.belongsTo(models.Company, { foreignKey: "company_id", as: "company" });
	};

	return BudgetCategory;
};
